/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: mach_msg_header_tPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the mach_msg_header_tPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=mach_msg_header_t.class)
public class mach_msg_header_tPointer extends StructurePointer {

	// NULL
	public static final mach_msg_header_tPointer NULL = new mach_msg_header_tPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected mach_msg_header_tPointer(long address) {
		super(address);
	}

	public static mach_msg_header_tPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static mach_msg_header_tPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static mach_msg_header_tPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new mach_msg_header_tPointer(address);
	}

	public mach_msg_header_tPointer add(long count) {
		return mach_msg_header_tPointer.cast(address + (mach_msg_header_t.SIZEOF * count));
	}

	public mach_msg_header_tPointer add(Scalar count) {
		return add(count.longValue());
	}

	public mach_msg_header_tPointer addOffset(long offset) {
		return mach_msg_header_tPointer.cast(address + offset);
	}

	public mach_msg_header_tPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public mach_msg_header_tPointer sub(long count) {
		return mach_msg_header_tPointer.cast(address - (mach_msg_header_t.SIZEOF * count));
	}

	public mach_msg_header_tPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public mach_msg_header_tPointer subOffset(long offset) {
		return mach_msg_header_tPointer.cast(address - offset);
	}

	public mach_msg_header_tPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public mach_msg_header_tPointer untag(long mask) {
		return mach_msg_header_tPointer.cast(address & ~mask);
	}

	public mach_msg_header_tPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return mach_msg_header_t.SIZEOF;
	}

	// Implementation methods

	// mach_msg_bits_t msgh_bits
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_bitsOffset_", declaredType="mach_msg_bits_t")
	public UDATA msgh_bits() throws CorruptDataException {
		return new U32(getIntAtOffset(mach_msg_header_t._msgh_bitsOffset_));
	}

	// mach_msg_bits_t msgh_bits
	public UDATAPointer msgh_bitsEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_bitsOffset_));
	}

	// mach_msg_id_t msgh_id
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_idOffset_", declaredType="mach_msg_id_t")
	public IDATA msgh_id() throws CorruptDataException {
		return new I32(getIntAtOffset(mach_msg_header_t._msgh_idOffset_));
	}

	// mach_msg_id_t msgh_id
	public IDATAPointer msgh_idEA() throws CorruptDataException {
		return IDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_idOffset_));
	}

	// mach_port_t msgh_local_port
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_local_portOffset_", declaredType="mach_port_t")
	public UDATA msgh_local_port() throws CorruptDataException {
		return new U32(getIntAtOffset(mach_msg_header_t._msgh_local_portOffset_));
	}

	// mach_port_t msgh_local_port
	public UDATAPointer msgh_local_portEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_local_portOffset_));
	}

	// mach_port_t msgh_remote_port
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_remote_portOffset_", declaredType="mach_port_t")
	public UDATA msgh_remote_port() throws CorruptDataException {
		return new U32(getIntAtOffset(mach_msg_header_t._msgh_remote_portOffset_));
	}

	// mach_port_t msgh_remote_port
	public UDATAPointer msgh_remote_portEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_remote_portOffset_));
	}

	// mach_msg_size_t msgh_size
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_sizeOffset_", declaredType="mach_msg_size_t")
	public UDATA msgh_size() throws CorruptDataException {
		return new U32(getIntAtOffset(mach_msg_header_t._msgh_sizeOffset_));
	}

	// mach_msg_size_t msgh_size
	public UDATAPointer msgh_sizeEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_sizeOffset_));
	}

	// mach_port_name_t msgh_voucher_port
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_msgh_voucher_portOffset_", declaredType="mach_port_name_t")
	public UDATA msgh_voucher_port() throws CorruptDataException {
		return new U32(getIntAtOffset(mach_msg_header_t._msgh_voucher_portOffset_));
	}

	// mach_port_name_t msgh_voucher_port
	public UDATAPointer msgh_voucher_portEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(mach_msg_header_t._msgh_voucher_portOffset_));
	}

}
